/*
ktou Version 1.03
Copyright 2013 Sogaya
To add a character to the file.
Please enter "ktou -V" for usage.
*/

#define BUFFER_SIZE 256
#define CHARACTER_TO_BE_ADDED ' '
#define USAGE "ktou Version 1.03\nktou file_name\nktou file_name 20 \nktou file_name A \n"
#define VOYA_CTRL_TEXT "voyaCtrl.txt"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[]) {
	char *stop;
	char file_name[BUFFER_SIZE];
	FILE *p;
	int c;

	switch(argc) {
	case 2:
		if(! strcmp(argv[1], "-V") ) {  /* ktou -V */
			fprintf(stderr, USAGE);
			return 1;
		}

 /* ktou file_name */
		strcpy(file_name, argv[1]);
		c = CHARACTER_TO_BE_ADDED;
		break;
	case 3: /* ktou file_name 20 */
		strcpy(file_name, argv[1]);
		c = (int)strtol(argv[2], &stop, 16); /* hexadecimal */
		break;
	default:
		strcpy(file_name, VOYA_CTRL_TEXT);
		c = CHARACTER_TO_BE_ADDED;
		break;
	}

	p = fopen(file_name, "a");
	fputc(c, p);
	fclose(p);
	return 0;
}
