/*
ovee Version 1.03
To remove files according to remove_e.txt
Copyright 2015 Sogaya

Watcom

*/

#define VERSION 1.03
#define BUFFER_SIZE 256
#define REMOVE_E_TEXT "remove_e.txt"
#define TRUE 1
#include <stdio.h>
#include <string.h>

typedef int BOOL;

void chopped(char *s) {
    char *p;

/* Removing the new-line character */
    p = strrchr(s, '\n');
    if(p != NULL) {
        *p = '\0';
    }
}

int main(int argc, char *argv[]) {
    char *p;
    char c[BUFFER_SIZE];
    char file_name[] = REMOVE_E_TEXT;
    FILE *file;

    switch(argc) {
    case 1:
        break;
    case 2:
        if(! strcmp(argv[1], "-V") ) {
            fprintf(stderr, "ovee Version %1.2f\n\n", VERSION);
            fprintf(stderr, "ovee\n");
            fprintf(stderr, "ovee -V");
            return 1;
        }

        break;
    default:
        fprintf(stderr, "ovee Version %1.2f\n\n", VERSION);
        fprintf(stderr, "ovee\n");
        fprintf(stderr, "ovee -V");
        return 1;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "%s\n", file_name);
        return 1;
    }

    for(;;) {
        p = fgets(c, BUFFER_SIZE, file);
        if(p == NULL) {
            break;
        }

        chopped(c);
        remove(c);
    }

    fclose(file);
    return 0;
}
