#ifndef VOYA_CONTROL_H
#define VOYA_CONTROL_H

#pragma warn -8057

#include <fstream>
#include <iostream>
#include <sstream>
#include "Controllable.h"
#include "ModalDialog.h"
#include "struct_vs.h"
#include "voyaID.h"

class VoyaControl : public ModalDialog {
    const int INFO_LABEL_HEIGHT, CONTROL_HEIGHT, CONTROL_WIDTH;
    int inside, messages, priority;

    bool writeVoyaCtrlText();
    void readVoyaCtrlText();
    void setInside(bool b);
    void setPriority(int p);
    void setMessages(bool b);

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VoyaControl(HINSTANCE i, HWND h);
};

BOOL CALLBACK controlDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);

#endif // VOYA_CONTROL_H
