#ifndef VOYAFILE_H
#define VOYAFILE_H

#define DIGITS_SIZE 10
#define METACHARACTERS 9
#define SEED_LENGTH 4
#define TENTH_CHARACTER 16
#define TIME_USED_AS_SEED 0L
#include <iostream>
#include "mt19937ar.h"
#include "voyaID.h"

bool metaCharacterIncluded(char *sequence);
bool tenthCharacterOfTori(int tail);
char *getLine(char *p, char *line);
char lowerCaseOf(int i);
char upperCaseOf(int i);
int charToInteger(char c);
int cstring_to_integer(char *p);
int hexadecimal_cstring_to_integer(char *p);
int removeComment(char *line);
int sumOfWeight(double sum);
long tickCount(); // voyaThread.cpp
unsigned long randomIndex();
void copyThree(char *part, char *digits, int i);
void setMT(long n, int repetition);

#endif // VOYAFILE_H
