#ifndef DIVIDABLE_H
#define DIVIDABLE_H

#define FIELD_COUNT 12
#include <string>

class Dividable {
    char r[2];

protected:
    bool isDigit(std::string & h) {
        strcpy(r, h.c_str() );
        if('0' <= r[0] && r[0] <= '9') {
            return true;
        }

        return false;
    }

public:
    int i, limit;
    std::string a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, c, g, quote;

    virtual std::string scanningDigits(std::string &) = 0;
    virtual std::string scanning(std::string &) = 0;
    virtual ~Dividable(){}

    void setQuote(std::string & s) {
        const std::string q("\"");

        r[0] = 0;
        r[1] = 0;
        i = 0;
        limit = s.length();
        quote = q;
    }

    int getFieldCount () const {
        return FIELD_COUNT;
    }

    int itemCount() {
        int item_count = 0;
        if( a0.length() > 0 ) { item_count += 1; }
        if( a1.length() > 0 ) { item_count += 1; }
        if( a2.length() > 0 ) { item_count += 1; }
        if( a3.length() > 0 ) { item_count += 1; }
        if( a4.length() > 0 ) { item_count += 1; }
        if( a5.length() > 0 ) { item_count += 1; }
        if( a6.length() > 0 ) { item_count += 1; }
        if( a7.length() > 0 ) { item_count += 1; }
        if( a8.length() > 0 ) { item_count += 1; }
        if( a9.length() > 0 ) { item_count += 1; }
        if( a10.length() > 0 ) { item_count += 1; }
        if( a11.length() > 0 ) { item_count += 1; }
        return item_count;
    }

    std::string a(int);
};

class Dividing : public Dividable {
    const std::string GAP;
    std::string scanningDigits(std::string &);
    std::string scanning(std::string &);

public:
    Dividing(std::string & s, bool digits): GAP(" ") {
        setQuote(s);

        if(digits) {
            a0 = scanningDigits(s);
            a1 = scanningDigits(s);
            a2 = scanningDigits(s);
            a3 = scanningDigits(s);
            a4 = scanningDigits(s);
            a5 = scanningDigits(s);
            a6 = scanningDigits(s);
            a7 = scanningDigits(s);
            a8 = scanningDigits(s);
            a9 = scanningDigits(s);
            a10 = scanningDigits(s);
            a11 = scanningDigits(s);
        } else {
            a0 = scanning(s);
            a1 = scanning(s);
            a2 = scanning(s);
            a3 = scanning(s);
            a4 = scanning(s);
            a5 = scanning(s);
            a6 = scanning(s);
            a7 = scanning(s);
            a8 = scanning(s);
            a9 = scanning(s);
            a10 = scanning(s);
            a11 = scanning(s);
        }
    }

    Dividing(std::string & s): GAP(" ") {
        setQuote(s);
        a0 = scanning(s);
        a1 = scanning(s);
        a2 = scanning(s);
        a3 = scanning(s);
        a4 = scanning(s);
        a5 = scanning(s);
        a6 = scanning(s);
        a7 = scanning(s);
        a8 = scanning(s);
        a9 = scanning(s);
        a10 = scanning(s);
        a11 = scanning(s);
    }

    ~Dividing(){}
};

class DividingCSV : public Dividable {
    const std::string COMMA;
    std::string scanningDigits(std::string &);
    std::string scanning(std::string &);

public:
    DividingCSV(std::string & s, bool digits): COMMA(",") {
        setQuote(s);

        if(digits) {
            a0 = scanningDigits(s);
            a1 = scanningDigits(s);
            a2 = scanningDigits(s);
            a3 = scanningDigits(s);
            a4 = scanningDigits(s);
            a5 = scanningDigits(s);
            a6 = scanningDigits(s);
            a7 = scanningDigits(s);
            a8 = scanningDigits(s);
            a9 = scanningDigits(s);
            a10 = scanningDigits(s);
            a11 = scanningDigits(s);
        } else {
            a0 = scanning(s);
            a1 = scanning(s);
            a2 = scanning(s);
            a3 = scanning(s);
            a4 = scanning(s);
            a5 = scanning(s);
            a6 = scanning(s);
            a7 = scanning(s);
            a8 = scanning(s);
            a9 = scanning(s);
            a10 = scanning(s);
            a11 = scanning(s);
        }
    }

    DividingCSV(std::string & s): COMMA(",") {
        setQuote(s);
        a0 = scanning(s);
        a1 = scanning(s);
        a2 = scanning(s);
        a3 = scanning(s);
        a4 = scanning(s);
        a5 = scanning(s);
        a6 = scanning(s);
        a7 = scanning(s);
        a8 = scanning(s);
        a9 = scanning(s);
        a10 = scanning(s);
        a11 = scanning(s);
    }

    ~DividingCSV(){}
};

#endif // DIVIDABLE_H 
