CC        = bcc32
LINKER    = ilink32
RC        = brcc32

INCLUDE = -I"C:\borland\bcc55\Include"
LIB     = /L"C:\borland\bcc55\Lib"

CFLAGS = -O2 -w -tW
LFLAGS = /Tpe /c /aa
RFLAGS = -32

TARGET = vybm.exe
OBJS   = dividable.obj timename.obj modaldialog.obj vybm.obj
RESFILES = vybm.res

ALL : $(TARGET)

dividable.obj: Dividable.cpp
	$(CC) $(INCLUDE) -c Dividable.cpp
timename.obj: TimeName.cpp
	$(CC) $(INCLUDE) -c TimeName.cpp
modaldialog.obj: ModalDialog.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ModalDialog.cpp
vybm.obj: vybm.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c vybm.cpp
vybm.res: vybm.rc
	$(RC) $(RFLAGS) vybm.rc

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0w32.obj,$(TARGET),,cw32.lib import32.lib,,$(RESFILES)

clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
	del *.res
