#ifndef VOYATEST_H
#define VOYATEST_H

#pragma warn -8057

#define SALT_SIZE 2
#define TEN_FIGURE_TORI 10
#define TEXT_BOX_ROW_COUNT 3
#define VOYA_TEST_TEXT "voyaTest.txt"
#include <fstream>
#include <iostream>
#include <sstream>
#include "ModalDialog.h"
#include "voyaID.h"

class VoyaTest : public ModalDialog {
    const int INFO_LABEL_HEIGHT, TEST_HEIGHT, TEST_WIDTH, PARTITION_SIZE;
    const _STL::string EMPTY, PARTITION, PIPE, SEPARATOR;
    _STL::string h[TEXT_BOX_ROW_COUNT];

    bool testHexadecimal(_STL::string & s);
    bool testResults();
    bool writeVoyaTestText();
    void readVoyaTestText();

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VoyaTest(HINSTANCE i, HWND h);
};

BOOL CALLBACK testDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
bool testSalt(_STL::string & g);
char* crypt3(char*, char*);
void set_byte_table();

#endif // VOYATEST_H
