#ifndef STRUCT_VS_H
#define STRUCT_VS_H

#define LABEL_COUNT 34
#define SMALL_BUFFER_SIZE 256
#include <string>

typedef struct VYBM_CONTROL VYBM_CONTROL;
struct VYBM_CONTROL {
    bool backUp, kanjiDetails, reserve, narrowPane, removeFirst, serialNumber, shortPane, showWhere, widePane;
    int corner;
};

typedef struct VYBM_SETTING VYBM_SETTING;
struct VYBM_SETTING {
    char edited[ LABEL_COUNT + 1 ][SMALL_BUFFER_SIZE];
    char buffer[SMALL_BUFFER_SIZE];
    char log_file_name[SMALL_BUFFER_SIZE];
    HINSTANCE instance;
    int ascii_weight, capital_omega_weight, capital_ya_weight, capital_z_weight, cap_weight, circle_weight, cup_weight, double_integral_weight, exists_weight, hankaku_katakana_weight, heisei_weight, hiragana_weight, jis_level_one_kanji_weight, jis_level_two_kanji_weight, katakana_weight, keisen_weight, nine_weight, non_sampling, omega_weight, paragraph_weight, parallel_weight, roman_weight, square_meter_weight, ya_weight, z_weight;
    std::string label[ LABEL_COUNT + 1 ];
};

#endif // STRUCT_VS_H
